/**
 * This file Copyright (c) 2018 Magnolia International
 * Ltd.  (http://www.magnolia-cms.com). All rights reserved.
 *
 *
 * This file is dual-licensed under both the Magnolia
 * Network Agreement and the GNU General Public License.
 * You may elect to use one or the other of these licenses.
 *
 * This file is distributed in the hope that it will be
 * useful, but AS-IS and WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE, TITLE, or NONINFRINGEMENT.
 * Redistribution, except as permitted by whichever of the GPL
 * or MNA you select, is prohibited.
 *
 * 1. For the GPL license (GPL), you can redistribute and/or
 * modify this file under the terms of the GNU General
 * Public License, Version 3, as published by the Free Software
 * Foundation.  You should have received a copy of the GNU
 * General Public License, Version 3 along with this program;
 * if not, write to the Free Software Foundation, Inc., 51
 * Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * 2. For the Magnolia Network Agreement (MNA), this file
 * and the accompanying materials are made available under the
 * terms of the MNA which accompanies this distribution, and
 * is available at http://www.magnolia-cms.com/mna.html
 *
 * Any modifications to this file must keep this entire header
 * intact.
 *
 */
package info.magnolia.ui.vaadin.layout;

import info.magnolia.ui.vaadin.gwt.shared.Range;
import info.magnolia.ui.vaadin.layout.data.ThumbnailContainer;

import java.util.List;

import com.vaadin.server.Resource;
import com.vaadin.ui.IconGenerator;
import com.vaadin.ui.ItemCaptionGenerator;
import com.vaadin.v7.data.Container;
import com.vaadin.v7.data.Container.Ordered;

/**
 *
 * References to 'thumbnail' in method or class names might remain.
 *
 * @deprecated since 6.2 - use {@link LazyThumbnailLayout} instead.
 */
@Deprecated
public class CompatibilityThumbnailLayout extends LazyLayout<Object> implements Container.Viewer, Container.ItemSetChangeListener {

    private ThumbnailContainer container;

    @Override
    public void setContainerDataSource(Container newDataSource) {
        if (!(newDataSource instanceof ThumbnailContainer)) {
            throw new IllegalArgumentException("Container must implement info.magnolia.ui.vaadin.layout.data.ThumbnailContainer...");
        }

        if (this.container instanceof Container.ItemSetChangeNotifier) {
            ((Container.ItemSetChangeNotifier) this.container).removeItemSetChangeListener(this);
        }

        this.container = (ThumbnailContainer) newDataSource;

        if (this.container instanceof Container.ItemSetChangeNotifier) {
            ((Container.ItemSetChangeNotifier) this.container).addItemSetChangeListener(this);
        }

        refresh();
    }

    @Override
    public Ordered getContainerDataSource() {
        return container;
    }

    public void setSelectedItemId(Object selectedItemId) {
        if (selectedItemId == null) {
            this.getState().selection.selectedIndices.clear();
        } else {
            this.getState().selection.toggleSelection(-1);
            this.getState().selection.toggleSelection(container.indexOfId(selectedItemId));
        }

        updateSelectionIndices();
    }

    @Override
    public void containerItemSetChange(Container.ItemSetChangeEvent event) {
        refresh();
    }

    @Override
    protected ItemCaptionGenerator<Object> getItemCaptionGenerator() {
        return item -> String.valueOf(this.container.getCaptionProperty(item).getValue());
    }

    @Override
    protected IconGenerator<Object> getItemResourceGenerator() {
        return id -> {
            ThumbnailContainer container = ((ThumbnailContainer) this.getContainerDataSource());
            final Object resource = container.getThumbnailProperty(id).getValue();
            boolean isRealResource = resource instanceof Resource;
            if (isRealResource) {
                return (Resource) resource;
            }
            return null;
        };
    }

    @Override
    public int size() {
        return this.container.size();
    }

    @Override
    protected List fetchItems(Range added) {
        return container.getItemIds(added.getStart(), added.length());
    }
}
